#!/usr/bin/python

from run_domino import run_domino
import sys
import IMP
import IMP.atom
from assembly_input_reader import AssemblyReader
import fitting_solutions_reader
def usage():
  if len(sys.argv) != 2:
    print sys.argv[0] + " <assembly.input> "
    print "Report the best sampled transformation for each protein (for benchmarking)."
    sys.exit()

def run(asmb_fn):
  asmb=AssemblyReader(asmb_fn)
  for p in asmb.proteins:
    all_trans=fitting_solutions_reader.read_fitting_records(p.transformations_fn)
    #find the one with the lowest rmsd
    lowest_index=0
    for i,t in enumerate(all_trans):
      if t.rmsd2ref<all_trans[lowest_index].rmsd2ref:
        lowest_index=i
    print "for: ", p.prot_fn, " best fit of index " , lowest_index , " with rmsd " , all_trans[lowest_index].rmsd2ref


if __name__ == '__main__':
  usage()
  #load assembly data
  run(sys.argv[1])
