#!/usr/bin/python

import os,sys
from assembly_input_reader import AssemblyReader, read_components
from restraint_filename_generator import create_pairwise_filename
import IMP

def usage():
    if len(sys.argv) != 2:
        print sys.argv[0] + " <assembly.input>"
        sys.exit()

def run(asmb_fn):
    asmb= AssemblyReader(asmb_fn)
    mdl=IMP.Model()
    mhs = read_components(asmb,mdl)
    #add domino attribute
    num_comp=len(asmb.proteins)
    for i in range(num_comp):
        mhs[i].get_particle().add_attribute(IMP.domino.node_name_key(),asmb.proteins[i].name)        
    for i in range(num_comp):
        p1=mhs[i].get_particle()
        for j in range(i+1,num_comp):
            p2=mhs[j].get_particle()
            output_fn=create_pairwise_filename(p1,p2)
            command="/opt/multifit/utils/calculate_pairwise_terms.py " + asmb_fn + " " + str(i) + " " + str(j) + " " + output_fn
            print (command)
            os.system(command)

            
if __name__=="__main__":
    usage()
    run(sys.argv[1])

