#!/usr/bin/python

import os,sys
from assembly_input_reader import AssemblyReader, read_components
import restraint_filename_generator
import IMP

def usage():
    if len(sys.argv) != 2:
        print sys.argv[0] + " <assembly.input>"
        sys.exit()

def run(asmb_fn):
    asmb= AssemblyReader(asmb_fn)
    mdl=IMP.Model()
    mhs = read_components(asmb,mdl)
    #add domino attribute
    num_comp=len(asmb.proteins)
    for i in range(num_comp):
        mhs[i].get_particle().add_attribute(IMP.domino.node_name_key(),asmb.proteins[i].name)
    for i in range(num_comp):
        p1=mhs[i].get_particle()
        output_fn=restraint_filename_generator.create_singleton_filename(p1)
        command="/opt/multifit/utils/calculate_single_terms.py " + asmb_fn + " " + str(i) + " " + output_fn
        print (command)
        os.system(command)

            
if __name__=="__main__":
    usage()
    run(sys.argv[1])

