#utlitity functions for creating a MultiFit sampling space

import IMP.domino
import fitting_solutions_reader


def set_mapped_discrete_sampling_space(orig_discrete_set,
                                       comp2ap,asmb_ap,dist_t):
      comps=orig_discrete_set.get_particles()
      new_discrete_set = IMP.multifit.create_mapped_discrete_set(orig_discrete_set,asmb_ap,comps,comp2ap,dist_t)
      sampler = IMP.domino.TransformationCartesianProductSampler(new_discrete_set,comps,True)
      return [new_discrete_set,sampler]
'''
load the assembly full discrete set of states
param[rbs] rbs the assembly rigid bodies
param[asmb] asmb the assembly data
note: need to keep all of the output values for swig memory managment issues
'''
def load_full_discrete_set(rbs,asmb):
    discrete_set =IMP.domino.TransformationMappedDiscreteSet(rbs)
    trans_ps=[]
    mdl=rbs[0].get_model()
#add valid transformation for each rigid body
    for i,rb in enumerate(rbs):
        rb_p=rb.get_particle()
        ts=fitting_solutions_reader.read_fitting_records(
                        asmb.proteins[i].transformations_fn)
        for j,t in enumerate(ts):
          state_p=IMP.Particle(mdl)
          IMP.domino.Transformation.setup_particle(state_p,t.transformation,j)
          state_p.add_attribute(IMP.IntKey("orig_ind"),j)
          ####state index
          #IMP.domino.Transformation.setup_particle(state_p,t,ind)
          ####
          discrete_set.add_mapped_state(rb_p,state_p)
          trans_ps.append(state_p)
    sampler = IMP.domino.TransformationCartesianProductSampler(discrete_set,rbs,True)
    return [trans_ps,discrete_set,sampler]

