#!/usr/bin/python

import sys
import os
import IMP
import IMP.core
import IMP.restrainer

def usage():
    if len(sys.argv) != 3:
        print sys.argv[0] +" <representation.xml> <restraints.xml>"
        sys.exit()
def run(rep_fn,res_fn):
    IMP.set_log_level(IMP.VERBOSE)
    RepParser = IMP.restrainer.XMLRepresentation(rep_fn)
    RestraintParser = IMP.restrainer.XMLRestraint(res_fn)
    
    representation = RepParser.run()
    restraint = RestraintParser.run()
    mdl = representation.to_model()
    restraint.add_to_representation(representation)
    mhs = representation.model_decorator

    #o = IMP.core.ConjugateGradients()
    #o.set_threshold(1e-4)
    #o.set_model(Model)
    #dis=IMP.display.PDBOptimizerState(mhs, "test.%003d.pdb")
    #o.add_optimizer_state(dis)    
    #o.optimize(10)

    #IMP.atom.write_pdb (root_hierarchy, "RNAIIP_after_optimize3.pdb")
    print "The model value is :", mdl.evaluate(False)
if __name__ == '__main__':
    usage()
    run(sys.argv[1],sys.argv[2])
